// DuoBot
// ------------------------------------------------------------------
// Copright  2005 - Stewart Gray - All Rights Reserved.
//
// DuoBot.h: interface for the CDuoBot class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(DUOBOT_H)
#define DUOBOT_H

#include "Sprite.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Sprite.h"
#include "Zap.h"	// Added by ClassView

typedef struct 
{
	bool bShoot;
	bool isBlack;
	float x;
	float y;
	float dir;
} shootInfo;

class CDuoBot : public CSprite  
{
public:
	void setIsDead(bool value);
	bool getIsDead();
	hitType CollisionDetect(int x, int y, int w, int h);
	void setHitPoints(int value);
	int getHitPoints();
	void setWeaponBlack(bool value);
	bool getWeaponBlack();
	void toggleWeapon();
	bool Jump();
	void shootGun(shootInfo* ShootInfo);
	void Update(Uint32 deltaMilliSeconds, bool leftDown, bool rightDown);
	void faceRight();
	void faceLeft();
	bool bFaceLeft;
	void Init(SDL_Surface* spriteSheet);
	CDuoBot();
	virtual ~CDuoBot();

protected:
	int invincibleCount;
	bool bDead;
	int hitPoints;
	int iShootWait;
	bool bWeaponBlack;
	std::string* IDLE_RIGHT;
	std::string* IDLE_LEFT;
	std::string* JUMP_SHOOT_LEFT;
	std::string* JUMP_RIGHT;
	std::string* JUMP_SHOOT_RIGHT;
	std::string* JUMP_LEFT;	
	std::string* SHOOT_RIGHT;
	std::string* SHOOT_LEFT;
	std::string* WALK_RIGHT;
	std::string* WALK_LEFT;

	virtual void animationLoop();
};

#endif // !defined(DUOBOT_H)
