// DuoBot
// ------------------------------------------------------------------
// Copright  2005 - Stewart Gray - All Rights Reserved.
//
// NamedRectList.cpp: implementation of the CNamedRectList class.
//
//////////////////////////////////////////////////////////////////////

#include "NamedRectList.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNamedRectList::CNamedRectList()
{
	name = NULL;
	rectList = NULL;
	init();
}

CNamedRectList::~CNamedRectList()
{
	rectList->erase(rectList->begin(), rectList->end());
	delete rectList;
	delete name;
}

void CNamedRectList::addRect(int x, int y, int w, int h)
{
	SDL_Rect* tmp;

	tmp = new SDL_Rect;

	tmp->x = x;
	tmp->y = y;
	tmp->w = w;
	tmp->h = h;

	rectList->push_back(tmp);

}

void CNamedRectList::init()
{
	init("<Unnamed>");
}

void CNamedRectList::addRect(SDL_Rect* r)
{
	addRect(r->x, r->y, r->w, r->h);
}

SDL_Rect* CNamedRectList::Item(int index)
{
	if ((index >= 0) && (index < rectList->size()))
	{
		return rectList->at(index);
	}
	else
	{
		return NULL;
	}
}

void CNamedRectList::init(const char * Name)
{
	if (name != NULL)
		delete name;

	if (rectList != NULL)
	{
		rectList->erase(rectList->begin(), rectList->end());
		delete rectList;
	}

	name = new std::string(Name);
	rectList = new std::vector<SDL_Rect *>;
	
}

void CNamedRectList::init(std::string& Name)
{
	init(Name.c_str());
}

int CNamedRectList::getCount()
{
	return rectList->size();
}
