// DuoBot
// ------------------------------------------------------------------
// Copright  2005 - Stewart Gray - All Rights Reserved.
//
// Sprite.h: interface for the CSprite class.
//
//////////////////////////////////////////////////////////////////////

#include <SDL.h>
#include <vector>
#include "NamedRectList.h"

#if !defined(SPRITE_H)
#define SPRITE_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSprite  
{
public:
	float getY();
	void setY(float value);
	float getX();
	void setX(float value);
	void addAnimation(class CNamedRectList* const Animation);
	void setSpriteSheet(SDL_Surface* SpriteSheet);
	void nextFrame();
	int getFrame();
	void setFrame(int value);
	void setAnimation(std::string name);
	void setVisible(bool value);
	bool getVisible();
	void Draw(SDL_Surface* screen, int worldX, int worldY);
	CSprite();
	virtual ~CSprite();

protected:
	int iFrameWait;
	virtual void animationLoop();
	void clearAnimations();
	SDL_Surface* spriteSheet;
	int iFrame;
	bool bVisible;
	class CNamedRectList* currentAnimation;
	SDL_Rect writeRect;
	float footY;
	float footX;
	std::vector<class CNamedRectList *>* animations;
private:
	SDL_Rect posRect;
};

#endif // !defined(SPRITE_H)
