// DuoBot
// ------------------------------------------------------------------
// Copright  2005 - Stewart Gray - All Rights Reserved.
//
// Zap.cpp: implementation of the CZap class.
//
//////////////////////////////////////////////////////////////////////

#include "Zap.h"

const float PIXELS_PER_SECOND = 500.0;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CZap::CZap()
{
	bDead = true;
	bIsBlack = false;
	fDir = 1.0;
	maxDist = 0;
	DEFAULT = new std::string("DEFAULT");
}

CZap::~CZap()
{
	delete DEFAULT;
}

bool CZap::getIsBlack()
{
	return bIsBlack;
}

bool CZap::getIsWhite()
{
	return !bIsBlack;
}

void CZap::Init(SDL_Surface * spriteSheet, bool IsBlack, float x, float y, float Dir, float maximumDistance)
{
	setSpriteSheet(spriteSheet);
	CNamedRectList* animation;
	clearAnimations();

	footX = x;
	footY = y;
	fDir = Dir;
	maxDist = maximumDistance;
	bIsBlack = IsBlack;
	bDead = false;

	//This is all hard coded junk.

	animation = new CNamedRectList();
	animation->setName(*DEFAULT);
	
	animation->addRect(0, 0, 32, 32);

	addAnimation(animation);

	setAnimation(*DEFAULT);
}

bool CZap::getDead()
{
	return bDead;
}

void CZap::setDead(bool value)
{
	bDead = value;
}

void CZap::Update(float deltaMilliSeconds)
{
	float fDist;

	if (!bDead)
	{
		fDist = (deltaMilliSeconds * PIXELS_PER_SECOND) / 1000.0;
		maxDist-= fDist;
		footX += (fDir * fDist);
		if (maxDist <= 0)
		{
			bDead = true;
			setVisible(false);
		}
	}
}

float CZap::getCenterX()
{
	return footX;
}

float CZap::getCenterY()
{
	return footY - (currentAnimation->Item(iFrame)->h /2);
}

float CZap::getRadius()
{
	float retVal;

	retVal = (float) currentAnimation->Item(iFrame)->w;
	if ((float) currentAnimation->Item(iFrame)->h < retVal)
	{
		retVal = (float) currentAnimation->Item(iFrame)->h;
	}

	return retVal;
}
